export class CallCenter {
  queue = []

  receptionists = []

  callerCalling(caller) {
    this.queue.push(caller)
  }

  receptionistSigningIn(receptionist) {
    this.receptionists.push(receptionist)
  }

  receptionistSigningOff(receptionist) {
    this.receptionists = this.receptionists.filter(
      (item) => item !== receptionist
    )
  }

  isQueued(caller) {
    return !!this.queue.find((item) => item === caller)
  }

  handleCaller() {
    const receptionist = this.receptionists.find((r) => r.talkingTo === null)
    if (!receptionist) {
      return false
    }
    const caller = this.queue.shift()
    receptionist.talkTo(caller)
    return true
  }

  lunchbreak() {
    this.receptionists.forEach((r) => {
      if (r.talkingTo === null) {
        return
      }
      this.queue.push(r.talkingTo)
      r.hangup()
    })
  }
}
