---
title: Writing poetically
---

# Writing poetically

Not many programmers write poems, but quite a few write well. One might even argue that some write poetically?

Let's look at a few examples. Note their use of literary devices such as metaphors and personification to help us think about programming.

> Pascal is for building pyramids — imposing, breathtaking, static structures built by armies pushing heavy blocks into place. Lisp is for building organisms — imposing, breathtaking, dynamic structures built by squads fitting fluctuating myriads of simpler organisms into place. [...] As a result the pyramid must stand unchanged for a millennium; the organism must evolve or perish. ([Structure and Interpretation of Computer Programs](https://en.wikipedia.org/wiki/Structure_and_Interpretation_of_Computer_Programs), 1996, p. xvii)

> (...) SQLite also thrives at the edge of the network, fending for itself while providing fast and reliable data services to applications that would otherwise have dodgy connectivity. ([SQLite docs](https://web.archive.org/web/20230311174317/https://www.sqlite.org/whentouse.html))

> A calculator for humanity's peculiar conventions of time. ([D3.js docs on time intervals](https://github.com/d3/d3/blob/37b1960e0af52d12bc7bbea2ed932ea954c36d14/API.md#time-intervals-d3-time))

Sidenote to the above: It reminds me of Magic the Gathering's concept of [flavor text](https://mtg.fandom.com/wiki/Flavor_text).

> Suppose you are a page designer for an online store that specializes in selling mud. Let's call it "The Online Mud Store". Business is thriving. Customers place orders for various types and quantities of mud. They login to your site using their username and password, which allows them to view their orders and buy more mud. Right now, Terracotta Mud is on sale, which is very popular. ([Apache Velocity Project docs](https://velocity.apache.org/engine/1.7/user-guide.html#the-mud-store-example))

Sidenote to the above: I would argue that this alludes to the seminal article [Big Ball of Mud](http://laputan.org/mud/).

## Book recommendations

- [If Hemingway Wrote JavaScript by Angus Croll](https://nostarch.com/hemingway)
- [A poetry handbook by Mary Oliver](https://www.goodreads.com/book/show/71652.A_Poetry_Handbook)
- [Skriv godt, bli forstått av Cristine Calvert og Ove Dalen](https://www.universitetsforlaget.no/skriv-godt-bli-forstatt)
